searchNodes=[{"doc":"Main public API of Cryppo","ref":"Cryppo.html","title":"Cryppo","type":"module"},{"doc":"Decrypt encrypted data with an encryption keyExampleiex&gt; {encrypted_data, encryption_key} = Cryppo.encrypt(&quot;data to encrypt&quot;, &quot;Aes256Gcm&quot;) iex&gt; Cryppo.decrypt(encrypted_data, encryption_key) {:ok, &quot;data to encrypt&quot;}","ref":"Cryppo.html#decrypt/2","title":"Cryppo.decrypt/2","type":"function"},{"doc":"Decrypt data with a derived keyExampleiex&gt; encrypted = Cryppo.encrypt_with_derived_key(&quot;data to encrypt&quot;, &quot;Aes256Gcm&quot;, &quot;Pbkdf2Hmac&quot;, &quot;passphrase&quot;) iex&gt; {:ok, decrypted, _key} = Cryppo.decrypt_with_derived_key(encrypted, &quot;passphrase&quot;) iex&gt; decrypted &quot;data to encrypt&quot;","ref":"Cryppo.html#decrypt_with_derived_key/2","title":"Cryppo.decrypt_with_derived_key/2","type":"function"},{"doc":"List available derivation strategies","ref":"Cryppo.html#derivation_strategies/0","title":"Cryppo.derivation_strategies/0","type":"function"},{"doc":"Generate an encryption key for an encryption strategy and encrypt data with this encryption keyExampleiex&gt; {_encrypted_data, _encryption_key} = Cryppo.encrypt(&quot;data to encrypt&quot;, &quot;Aes256Gcm&quot;)","ref":"Cryppo.html#encrypt/2","title":"Cryppo.encrypt/2","type":"function"},{"doc":"Encrypt data with an encryption keyExampleiex&gt; encryption_key = Cryppo.generate_encryption_key(&quot;Aes256Gcm&quot;) iex&gt; _encrypted_data = Cryppo.encrypt(&quot;data to encrypt&quot;, &quot;Aes256Gcm&quot;, encryption_key)The encryption key must match the encryption strategy:iex&gt; encryption_key = Cryppo.generate_encryption_key(&quot;Aes256Gcm&quot;) iex&gt; Cryppo.encrypt(&quot;data to encrypt&quot;, &quot;Rsa4096&quot;, encryption_key) {:incompatible_key, [submitted_key_strategy: Cryppo.Aes256gcm, encryption_strategy: Cryppo.Rsa4096]}","ref":"Cryppo.html#encrypt/3","title":"Cryppo.encrypt/3","type":"function"},{"doc":"Encrypt data with a derived keyExampleiex&gt; _encrypted = Cryppo.encrypt_with_derived_key(&quot;data to encrypt&quot;, &quot;Aes256Gcm&quot;, &quot;Pbkdf2Hmac&quot;, &quot;passphrase&quot;)","ref":"Cryppo.html#encrypt_with_derived_key/4","title":"Cryppo.encrypt_with_derived_key/4","type":"function"},{"doc":"List available encryption strategies","ref":"Cryppo.html#encryption_strategies/0","title":"Cryppo.encryption_strategies/0","type":"function"},{"doc":"Generate an encryption key for an encryption strategyThe generated encrypted key is marked as belonging to the encryption strategy.Exampleiex&gt; _encryption_key = Cryppo.generate_encryption_key(&quot;Aes256Gcm&quot;)","ref":"Cryppo.html#generate_encryption_key/1","title":"Cryppo.generate_encryption_key/1","type":"function"},{"doc":"Load various Cryppo data structures from their serialized forms3 Cryppo data structures have their own serialization formats:Cryppo.EncryptedDataCryppo.EncryptedDataWithDerivedKeyCryppo.RsaSignatureCryppo.EncryptedData and Cryppo.EncryptedDataWithDerivedKey have two serialization formats: a legacy format and a more efficient current format. Both formats are loaded by Cryppo.load/1. Cryppo.serialize/2 will serialize structures using the new format.Examplesiex&gt; s = &quot;Aes256Gcm.WSDb2AmsF7LFOxYb.QUAAAAACYWQABQAAAG5vbmUABWF0ABAAAAAAY9Ck6LzVGiMdiWFK6N5BawVpdgAMAAAAAG_Yxh-I0gGNYoFRigA=&quot; iex&gt; {:ok, %Cryppo.EncryptedData{}} = Cryppo.load(s) iex&gt; s = &quot;Aes256Gcm.wW4M_sv_kMx14cC6.QUAAAAACYWQABQAAAG5vbmUABWF0ABAAAAAA8Aq84t28sMT9FL8cz-TmMQVpdgAMAAAAANahbwbkfWo18YuCMgA=.Pbkdf2Hmac.SzAAAAAQaQAJUwAABWl2ABQAAAAAuQTqZLVFO49lI6Kx454ffYQ9VV0QbAAgAAAAAA==&quot; iex&gt; {:ok, %Cryppo.EncryptedDataWithDerivedKey{}} = Cryppo.load(s) iex&gt; s = &quot;Sign.Rsa4096.V4JbRzpkud-3cHCGqDwGjS3TmRto5Te0iSAtD7oIzsDa83McBDYpU_eeswVZF9AGEvoAEQOCwpqJ_PgbjHKT2nHgLysK-btG6Nxk_K2J7A6Uq15X5QrOgIKTzC00dj1tzAN73u9lsRPKIfwPyp_Mlb6FNs1LoB7OvAusit6QPm8iAwHo4nOWBBUf3hO9b3gsWJ92FxnBsCLYFQj_zv4mnLHj7pDNVtq9Kp4hK6bgcIH4FZtyDKDr6bXEtlCGLDIY10UqNLylkagI36Gyafm-HnD57vRxjgHIGEsd2XcwDJ8PqqrzSYNxl-RyWD3wq0nXE_1rYJ7k1AKLM5G1Hg8B2whqcXpQ52x3zVFCAjlU9GNhT6pdUBxQYw09va7fe2w517PrwwMe90MW87fj3G7dGEKT95cDLTx1d84ybIUFUJOGKY0FF4LL0E3UqWQ92kU4bh-DSTkNmgItX34fiBIOpQDbF238IkRYyFA8LfMPfL-0_dnto9sH0E3Umi41qFvpA2Nq8r57FF4vCOSkXYWVfyitOkY_URqMLxS57azwZRBehJYDtvbqmzaYEDceeLjkxDi--Y10LT4Cz2SGiU--YDJM66PZ3Cp74gvDpsWlohcwYmMib5LrjdtvLOAtOZhoLZyGeeX0lDnwOum7lFRpJd8UIrOlTvpBo48ep2bpmgA=.VmVyaMO8dHVuZyB2ZXJib3Rlbg==&quot; iex&gt; {:ok, %Cryppo.RsaSignature{}} = Cryppo.load(s)","ref":"Cryppo.html#load/1","title":"Cryppo.load/1","type":"function"},{"doc":"Serialize various Cryppo data structures as a string3 Cryppo data structures have their own serialization formats:Cryppo.EncryptedDataCryppo.EncryptedDataWithDerivedKeyCryppo.RsaSignatureCryppo.EncryptedData and Cryppo.EncryptedDataWithDerivedKey have two serialization formats: a legacy format and a more efficient current format. Both formats are loaded by Cryppo.load/1. Cryppo.serialize/2 will serialize structures using the new format. In order to serialize a structure using the old format please use Cryppo.serialize(struct, version: :legacy).ExamplesCryppo.EncryptedData:iex&gt; {encrypted_data, _key} = Cryppo.encrypt(&quot;data to encrypt&quot;, &quot;Aes256Gcm&quot;) iex&gt; Cryppo.serialize(encrypted_data)Cryppo.EncryptedDataWithDerivedKey:iex&gt; &quot;data to encrypt&quot; ...&gt; |&gt; Cryppo.encrypt_with_derived_key(&quot;Aes256Gcm&quot;, &quot;Pbkdf2Hmac&quot;, &quot;passphrase&quot;) ...&gt; |&gt; Cryppo.serialize()Cryppo.RsaSignature:iex&gt; private_key = Cryppo.generate_encryption_key(&quot;Rsa4096&quot;) iex&gt; &quot;data to encrypt&quot; ...&gt; |&gt; Cryppo.Rsa4096.sign(private_key) ...&gt; |&gt; Cryppo.serialize()","ref":"Cryppo.html#serialize/2","title":"Cryppo.serialize/2","type":"function"},{"doc":"Name of an encryption or derivation strategyUse Cryppo.encryption_strategies/0 to get a list of encryption strategies. Use Cryppo.derivation_strategies/0 to get a list of derivation strategies.","ref":"Cryppo.html#t:encryption_strategy/0","title":"Cryppo.encryption_strategy/0","type":"type"},{"doc":"Module of an encryption or derivation strategy","ref":"Cryppo.html#t:encryption_strategy_module/0","title":"Cryppo.encryption_strategy_module/0","type":"type"},{"doc":"A struct for a derived encryption key and its derivation artefactsA Cryppo.EncryptedData struct may be marked as belonging to a certain key derivation strategy using field key_derivation_strategy containing the module of the key derivation.A Cryppo.DerivedKey comes in 2 flavors:With a derived encryption key. When used for encryption or decryption this key will be usedWithout an encryption key. Encrypting or decrypting with this struct requires a passphrase to derive the key","ref":"Cryppo.DerivedKey.html","title":"Cryppo.DerivedKey","type":"module"},{"doc":"","ref":"Cryppo.DerivedKey.html#current_version/0","title":"Cryppo.DerivedKey.current_version/0","type":"function"},{"doc":"","ref":"Cryppo.DerivedKey.html#load_artefacts/1","title":"Cryppo.DerivedKey.load_artefacts/1","type":"function"},{"doc":"Struct Cryppo.DerivedKeyA Cryppo.DerivedKey struct containsencryption_key - nil or a Cryppo.EncryptionKeykey_derivation_strategy - module of the key derivation strategysalt - salt used for key derivationiter - number of iterations for key derivationlength - key lengthhash - hash function for key derivation","ref":"Cryppo.DerivedKey.html#t:t/0","title":"Cryppo.DerivedKey.t/0","type":"type"},{"doc":"A struct for encrypted data and encryption artefactsAn Cryppo.EncryptedData struct may be marked as belonging to a certain encryption strategy using field encryption_strategy_module containing the module of the encryption strategy.Can also contain encryption artefacts if they are part of the encryption strategy.","ref":"Cryppo.EncryptedData.html","title":"Cryppo.EncryptedData","type":"module"},{"doc":"Initialize a struct with the module of an encryption strategy, a binary with encrypted data, and encryption_artefacts.","ref":"Cryppo.EncryptedData.html#new/3","title":"Cryppo.EncryptedData.new/3","type":"function"},{"doc":"Struct Cryppo.EncryptedDataA Cryppo.EncryptedData struct containsencrypted_data: encrypted dataencryption_strategy_module: module of the encryption strategy to which the key belongsencryption_artefacts: a map with encryption artefacts","ref":"Cryppo.EncryptedData.html#t:t/0","title":"Cryppo.EncryptedData.t/0","type":"type"},{"doc":"A struct for a derived key and data encrypted with this derived key","ref":"Cryppo.EncryptedDataWithDerivedKey.html","title":"Cryppo.EncryptedDataWithDerivedKey","type":"module"},{"doc":"Struct Cryppo.EncryptedDataA Cryppo.EncryptedData struct containsencrypted_data: a Cryppo.EncryptedData structderived_key: a Cryppo.DerivedKey struct","ref":"Cryppo.EncryptedDataWithDerivedKey.html#t:t/0","title":"Cryppo.EncryptedDataWithDerivedKey.t/0","type":"type"},{"doc":"A struct for encryption artefactsEach encryption strategy can use Cryppo.EncryptionArtefacts if it makes sense for the underlying cipher.","ref":"Cryppo.EncryptionArtefacts.html","title":"Cryppo.EncryptionArtefacts","type":"module"},{"doc":"","ref":"Cryppo.EncryptionArtefacts.html#current_version/0","title":"Cryppo.EncryptionArtefacts.current_version/0","type":"function"},{"doc":"Struct Cryppo.EncryptionArtefacts","ref":"Cryppo.EncryptionArtefacts.html#t:t/0","title":"Cryppo.EncryptionArtefacts.t/0","type":"type"},{"doc":"A struct to wrap an encryption keyAn EncryptionKey struct may be marked as belonging to a certain encryption strategy using field encryption_strategy_module containing the module of the encryption strategy.Depending on the encryption strategy the key can be a binary or a tuple.Keys must be guarded and protected, that is why the Inspect protocol has been overridden for this struct to disable pretty-printing.Should you need to access the key, access it via field key.","ref":"Cryppo.EncryptionKey.html","title":"Cryppo.EncryptionKey","type":"module"},{"doc":"Initialize a struct with an encryption key","ref":"Cryppo.EncryptionKey.html#new/1","title":"Cryppo.EncryptionKey.new/1","type":"function"},{"doc":"Initialize a struct with an encryption key and the module of an encryption strategy","ref":"Cryppo.EncryptionKey.html#new/2","title":"Cryppo.EncryptionKey.new/2","type":"function"},{"doc":"A binary key","ref":"Cryppo.EncryptionKey.html#t:binary_key/0","title":"Cryppo.EncryptionKey.binary_key/0","type":"type"},{"doc":"Encryption keyAn encryption key may me a tuple or a binary depending on the encryption strategy","ref":"Cryppo.EncryptionKey.html#t:internal_key/0","title":"Cryppo.EncryptionKey.internal_key/0","type":"type"},{"doc":"Struct EncryptionKeyA Cryppo.EncryptionKey struct containskey: the key itselfencryption_strategy_module: module of the encryption strategy to which the key belongs","ref":"Cryppo.EncryptionKey.html#t:t/0","title":"Cryppo.EncryptionKey.t/0","type":"type"},{"doc":"Encryption strategy RSA with 4096-bit keys and some RSA-specific functionsFor encryption and decryption please use functions in module Cryppo. This module also contains logic for PEMs, singing and verification.","ref":"Cryppo.Rsa4096.html","title":"Cryppo.Rsa4096","type":"module"},{"doc":"Loads and initializes a Cryppo.EncryptionKey struct from a string with a PEM.Examplesiex&gt; pem = &quot;-----BEGIN RSA PRIVATE KEY-----\\n&quot; &lt;&gt; ...&gt; &quot;MIICWwIBAAKBgQDKCUh7F4p5btzcSLBaToHvD3rCZX4fMaDtjkN5TwmC3/6iQzD5\\n&quot; &lt;&gt; ...&gt; &quot;tn396BzDTdQ16HuuZ+eN+KQSa1QWr2h1DB13nVP+moeyLVC8BShiM3NBRn77r7Lr\\n&quot; &lt;&gt; ...&gt; &quot;sWooM3mwnSvMPWWnBj1c+0tbO7zfur5wQdzBl66HrHgHt+Bz6f+dDj+aVwIDAQAB\\n&quot; &lt;&gt; ...&gt; &quot;AoGAMHh3rihgrW9+h07dGF1baOoyzm6hCoTSkguefn0K0B5DLdSm7FHu+jp0pBqI\\n&quot; &lt;&gt; ...&gt; &quot;/gHvolEFSZdMbarYOrUMf4BPlRSarCjjxf/beV4Pj/UQrCkDmNBBVJp33Sy8HEdb\\n&quot; &lt;&gt; ...&gt; &quot;Wrzk+k8NcAS1UR4R6EW9JrUz0mMwX6CsvG2zZMbpS/Q9KXkCQQDwmCXjOTPQ+bxW\\n&quot; &lt;&gt; ...&gt; &quot;K4gndHnXD5QkKNcTdFq64ef23R6AY0XEGkiRLDXZZA09hDIACgSSfk1Qbo0SJSvU\\n&quot; &lt;&gt; ...&gt; &quot;TAR8A6clAkEA1vkWJ5qUo+xuIZB+2604LRco1GYAj5/fZ2kvUMjbOdCFgFaDVzJY\\n&quot; &lt;&gt; ...&gt; &quot;X2pzLkk7RZNgPvXcRAgX7FlWmm4jwZzQywJARrHeSCMRx7DqF0PZUQaXmorYU7uw\\n&quot; &lt;&gt; ...&gt; &quot;XuYMluc0WsRkZwNEh7fVZNrhw8vzXAUREBPhfg4gt6aUSyWi+FGR68LDBQJAC55O\\n&quot; &lt;&gt; ...&gt; &quot;ujk6i1l94kaC9LB59sXnqQMSSLDlTBt9OSqB3rAMZxFF6/KGoDGKpBfFIk+CxiRX\\n&quot; &lt;&gt; ...&gt; &quot;kT22vUleyt3lBNPK3QJAEr56asvREcIDFkbs7Ebjev4U1PL58w78ipp49Ti5FiwH\\n&quot; &lt;&gt; ...&gt; &quot;vR9vuGcUcIDcWKOl05t4D35F5A/DskP6dGYA1cuWNg==\\n&quot; &lt;&gt; ...&gt; &quot;-----END RSA PRIVATE KEY-----\\n\\n&quot; ...&gt; {:ok, encryption_key} = Cryppo.Rsa4096.from_pem(pem)","ref":"Cryppo.Rsa4096.html#from_pem/1","title":"Cryppo.Rsa4096.from_pem/1","type":"function"},{"doc":"Extracts a public key from a private keyExtracts a public key from a Cryppo.EncryptionKey struct with an RSA private key or from an RSA private key in the native Erlang type rsa_private_key/0ExamplesWith a Cryppo.EncryptionKey struct:iex&gt; public_key = &quot;Rsa4096&quot; ...&gt; |&gt; Cryppo.generate_encryption_key() ...&gt; |&gt; Cryppo.Rsa4096.private_key_to_public_key() ...&gt; elem(public_key, 0) :RSAPublicKeyWith a native Erlang key:iex&gt; public_key = {:rsa, 4_096, 65_537} ...&gt; |&gt; :public_key.generate_key() ...&gt; |&gt; Cryppo.Rsa4096.private_key_to_public_key() ...&gt; elem(public_key, 0) :RSAPublicKey","ref":"Cryppo.Rsa4096.html#private_key_to_public_key/1","title":"Cryppo.Rsa4096.private_key_to_public_key/1","type":"function"},{"doc":"Signs data with a private keyThe private key can be one of the following:a Cryppo.EncryptionKey structa private key as native Erlang type rsa_private_key/0a PEM with a private RSA keyExamplesWith a Cryppo.EncryptionKey struct:iex&gt; encryption_key = Cryppo.generate_encryption_key(&quot;Rsa4096&quot;) iex&gt; _signature = %Cryppo.RsaSignature{} = Cryppo.Rsa4096.sign(&quot;data to sign&quot;, encryption_key)With a private key as native Erlang type rsa_private_key/0iex&gt; private_key = :public_key.generate_key({:rsa, 4_096, 65_537}) iex&gt; _signature = %Cryppo.RsaSignature{} = Cryppo.Rsa4096.sign(&quot;data to sign&quot;, private_key)With a PEMiex&gt; pem = &quot;-----BEGIN RSA PRIVATE KEY-----\\n&quot; &lt;&gt; ...&gt; &quot;MIICWwIBAAKBgQDKCUh7F4p5btzcSLBaToHvD3rCZX4fMaDtjkN5TwmC3/6iQzD5\\n&quot; &lt;&gt; ...&gt; &quot;tn396BzDTdQ16HuuZ+eN+KQSa1QWr2h1DB13nVP+moeyLVC8BShiM3NBRn77r7Lr\\n&quot; &lt;&gt; ...&gt; &quot;sWooM3mwnSvMPWWnBj1c+0tbO7zfur5wQdzBl66HrHgHt+Bz6f+dDj+aVwIDAQAB\\n&quot; &lt;&gt; ...&gt; &quot;AoGAMHh3rihgrW9+h07dGF1baOoyzm6hCoTSkguefn0K0B5DLdSm7FHu+jp0pBqI\\n&quot; &lt;&gt; ...&gt; &quot;/gHvolEFSZdMbarYOrUMf4BPlRSarCjjxf/beV4Pj/UQrCkDmNBBVJp33Sy8HEdb\\n&quot; &lt;&gt; ...&gt; &quot;Wrzk+k8NcAS1UR4R6EW9JrUz0mMwX6CsvG2zZMbpS/Q9KXkCQQDwmCXjOTPQ+bxW\\n&quot; &lt;&gt; ...&gt; &quot;K4gndHnXD5QkKNcTdFq64ef23R6AY0XEGkiRLDXZZA09hDIACgSSfk1Qbo0SJSvU\\n&quot; &lt;&gt; ...&gt; &quot;TAR8A6clAkEA1vkWJ5qUo+xuIZB+2604LRco1GYAj5/fZ2kvUMjbOdCFgFaDVzJY\\n&quot; &lt;&gt; ...&gt; &quot;X2pzLkk7RZNgPvXcRAgX7FlWmm4jwZzQywJARrHeSCMRx7DqF0PZUQaXmorYU7uw\\n&quot; &lt;&gt; ...&gt; &quot;XuYMluc0WsRkZwNEh7fVZNrhw8vzXAUREBPhfg4gt6aUSyWi+FGR68LDBQJAC55O\\n&quot; &lt;&gt; ...&gt; &quot;ujk6i1l94kaC9LB59sXnqQMSSLDlTBt9OSqB3rAMZxFF6/KGoDGKpBfFIk+CxiRX\\n&quot; &lt;&gt; ...&gt; &quot;kT22vUleyt3lBNPK3QJAEr56asvREcIDFkbs7Ebjev4U1PL58w78ipp49Ti5FiwH\\n&quot; &lt;&gt; ...&gt; &quot;vR9vuGcUcIDcWKOl05t4D35F5A/DskP6dGYA1cuWNg==\\n&quot; &lt;&gt; ...&gt; &quot;-----END RSA PRIVATE KEY-----\\n\\n&quot; ...&gt; _signature = %Cryppo.RsaSignature{} = Cryppo.Rsa4096.sign(&quot;data to sign&quot;, pem)","ref":"Cryppo.Rsa4096.html#sign/2","title":"Cryppo.Rsa4096.sign/2","type":"function"},{"doc":"Converts an RSA key to PEM format.Can converta Cryppo.EncryptionKey structa public key as native Erlang type rsa_public_key/0a private key as native Erlang type rsa_private_key/0ExamplesWith a Cryppo.EncryptionKey structiex&gt; &quot;Rsa4096&quot; |&gt; Cryppo.generate_encryption_key() |&gt; Cryppo.Rsa4096.to_pem()With a public key as native Erlang type rsa_public_key/0iex&gt; &quot;Rsa4096&quot; ...&gt; |&gt; Cryppo.generate_encryption_key() ...&gt; |&gt; Cryppo.Rsa4096.private_key_to_public_key() ...&gt; |&gt; Cryppo.Rsa4096.to_pem()With a private key as native Erlang type rsa_private_key/0iex&gt; encryption_key = Cryppo.generate_encryption_key(&quot;Rsa4096&quot;) iex&gt; Cryppo.Rsa4096.to_pem(encryption_key.key)","ref":"Cryppo.Rsa4096.html#to_pem/1","title":"Cryppo.Rsa4096.to_pem/1","type":"function"},{"doc":"Verifies an RSA signature with a public keyThe key for verification can be pretty much any format and type, private keys are also accepted:native Erlang types rsa_private_key/0 and rsa_public_key/0Cryppo.EncryptionKey structsPEMsExamplesWith a public key in the Erlang format:iex&gt; encryption_key = Cryppo.generate_encryption_key(&quot;Rsa4096&quot;) iex&gt; signature = Cryppo.Rsa4096.sign(&quot;data to sign&quot;, encryption_key) iex&gt; public_key = Cryppo.Rsa4096.private_key_to_public_key(encryption_key) iex&gt; Cryppo.Rsa4096.verify(signature, public_key) trueWith a private key in the Erlang format:iex&gt; encryption_key = Cryppo.generate_encryption_key(&quot;Rsa4096&quot;) iex&gt; signature = Cryppo.Rsa4096.sign(&quot;data to sign&quot;, encryption_key) iex&gt; Cryppo.Rsa4096.verify(signature, encryption_key.key) trueWith a Cryppo.EncryptionKey struct:iex&gt; encryption_key = Cryppo.generate_encryption_key(&quot;Rsa4096&quot;) iex&gt; signature = Cryppo.Rsa4096.sign(&quot;data to sign&quot;, encryption_key) iex&gt; Cryppo.Rsa4096.verify(signature, encryption_key) trueWith a PEMiex&gt; pem_with_private_key = &quot;-----BEGIN RSA PRIVATE KEY-----\\n&quot; &lt;&gt; ...&gt; &quot;MIICWwIBAAKBgQDKCUh7F4p5btzcSLBaToHvD3rCZX4fMaDtjkN5TwmC3/6iQzD5\\n&quot; &lt;&gt; ...&gt; &quot;tn396BzDTdQ16HuuZ+eN+KQSa1QWr2h1DB13nVP+moeyLVC8BShiM3NBRn77r7Lr\\n&quot; &lt;&gt; ...&gt; &quot;sWooM3mwnSvMPWWnBj1c+0tbO7zfur5wQdzBl66HrHgHt+Bz6f+dDj+aVwIDAQAB\\n&quot; &lt;&gt; ...&gt; &quot;AoGAMHh3rihgrW9+h07dGF1baOoyzm6hCoTSkguefn0K0B5DLdSm7FHu+jp0pBqI\\n&quot; &lt;&gt; ...&gt; &quot;/gHvolEFSZdMbarYOrUMf4BPlRSarCjjxf/beV4Pj/UQrCkDmNBBVJp33Sy8HEdb\\n&quot; &lt;&gt; ...&gt; &quot;Wrzk+k8NcAS1UR4R6EW9JrUz0mMwX6CsvG2zZMbpS/Q9KXkCQQDwmCXjOTPQ+bxW\\n&quot; &lt;&gt; ...&gt; &quot;K4gndHnXD5QkKNcTdFq64ef23R6AY0XEGkiRLDXZZA09hDIACgSSfk1Qbo0SJSvU\\n&quot; &lt;&gt; ...&gt; &quot;TAR8A6clAkEA1vkWJ5qUo+xuIZB+2604LRco1GYAj5/fZ2kvUMjbOdCFgFaDVzJY\\n&quot; &lt;&gt; ...&gt; &quot;X2pzLkk7RZNgPvXcRAgX7FlWmm4jwZzQywJARrHeSCMRx7DqF0PZUQaXmorYU7uw\\n&quot; &lt;&gt; ...&gt; &quot;XuYMluc0WsRkZwNEh7fVZNrhw8vzXAUREBPhfg4gt6aUSyWi+FGR68LDBQJAC55O\\n&quot; &lt;&gt; ...&gt; &quot;ujk6i1l94kaC9LB59sXnqQMSSLDlTBt9OSqB3rAMZxFF6/KGoDGKpBfFIk+CxiRX\\n&quot; &lt;&gt; ...&gt; &quot;kT22vUleyt3lBNPK3QJAEr56asvREcIDFkbs7Ebjev4U1PL58w78ipp49Ti5FiwH\\n&quot; &lt;&gt; ...&gt; &quot;vR9vuGcUcIDcWKOl05t4D35F5A/DskP6dGYA1cuWNg==\\n&quot; &lt;&gt; ...&gt; &quot;-----END RSA PRIVATE KEY-----\\n\\n&quot; ...&gt; signature = Cryppo.Rsa4096.sign(&quot;data to sign&quot;, pem_with_private_key) ...&gt; {:ok, key} = Cryppo.Rsa4096.from_pem(pem_with_private_key) ...&gt; {:ok, pem_with_public_key} = key ...&gt; |&gt; Cryppo.Rsa4096.private_key_to_public_key() ...&gt; |&gt; Cryppo.Rsa4096.to_pem() ...&gt; Cryppo.Rsa4096.verify(signature, pem_with_public_key) true","ref":"Cryppo.Rsa4096.html#verify/2","title":"Cryppo.Rsa4096.verify/2","type":"function"},{"doc":"RSA keys in PEM format","ref":"Cryppo.Rsa4096.html#t:pem/0","title":"Cryppo.Rsa4096.pem/0","type":"type"},{"doc":"Erlang type for RSA private keysThe native Erlang type for RSA private keys in module public_key are Erlang records visible from Elixir as tuples with 11 terms the first term being atom :RSAPrivateKey","ref":"Cryppo.Rsa4096.html#t:rsa_private_key/0","title":"Cryppo.Rsa4096.rsa_private_key/0","type":"type"},{"doc":"Erlang type for RSA public keysThe native Erlang type for RSA public keys in module public_key are Erlang records visible from Elixir as tuples with 3 terms the first term being atom :RSAPublicKey","ref":"Cryppo.Rsa4096.html#t:rsa_public_key/0","title":"Cryppo.Rsa4096.rsa_public_key/0","type":"type"},{"doc":"A struct for an RSA singature and the signed data","ref":"Cryppo.RsaSignature.html","title":"Cryppo.RsaSignature","type":"module"},{"doc":"Struct Cryppo.RsaSignatureA Cryppo.RsaSignature struct containssignature: RSA signaturedata: signed data","ref":"Cryppo.RsaSignature.html#t:t/0","title":"Cryppo.RsaSignature.t/0","type":"type"},{"doc":"CryppoExCryppoEx is a cryptographic library that enables you to encrypt and decrypt data. CryppoEx combines very different ciphers under one simplified API, and a set of serialization formats.CryppoEx is an Elixir port of Cryppo in Ruby and Cryppo-js used for the Meeco platform.CryppoEx uses Erlang modules crypto and public_key under the hood.","ref":"readme.html","title":"CryppoEx","type":"extras"},{"doc":"Add cryppo_ex as a dependency in your mix.exs:def deps do [ {:cryppo_ex, &quot;~&gt; 0.1&quot;} ] endRun mix deps.get to fetch CryppoEx.","ref":"readme.html#installation","title":"CryppoEx - Installation","type":"extras"},{"doc":"When encrypting data with a user-generated passphrase or password, use function Cryppo.encrypt_with_derived_key/4.The data will be encrypted with a cryptographically secure key that is derived from the passphrase:encryption_strategy = &quot;Aes256Gcm&quot; key_derivation_strategy = &quot;Pbkdf2Hmac&quot; passphrase = &quot;MyPassword!!&quot; data = &quot;some data to encrypt&quot; encrypted_data = Cryppo.encrypt_with_derived_key(data, encryption_strategy, key_derivation_strategy, passphrase)You can list all available encryption strategies with Cryppo.encryption_strategies/0, and all key derivation strategies with Cryppo.derivation_strategies/0.The encryption process will return a Cryppo.EncryptedDataWithDerivedKey struct that contains all the encryption artefacts necessary to decrypt the encrypted data. This structure can be serialized as a string using function Cryppo.serialize/1. The serialized payload can be stored directly in a data store.serialized = Cryppo.serialize(encrypted_data)The serialized payload can later be loaded by using Cryppo.load/1 and decrypted with Cryppo.decrypt_with_derived_key/2 and the passphrase:{:ok, encrypted} = Cryppo.load(serialized) {:ok, decrypted, _encryption_key} = Cryppo.decrypt_with_derived_key(encrypted, passphrase) IO.inspect(decrypted) #=&gt; &quot;some data to encrypt&quot;","ref":"readme.html#encrypt-and-decrypt-data-using-a-derived-key","title":"CryppoEx - Encrypt and decrypt data using a derived key","type":"extras"},{"doc":"You can also encrypt using your own generated key using functions the Cryppo.generate_encryption_key/1 and Cryppo.encrypt/3:encryption_strategy = &quot;Aes256Gcm&quot; data = &quot;some data to encrypt&quot; encryption_key = Cryppo.generate_encryption_key(encryption_strategy) encrypted = Cryppo.encrypt(data, encryption_strategy, encryption_key)The encryption process will return an Cryppo.EncryptedData struct that contains all the encryption artefacts necessary to decrypt the encrypted data.It is also possible to generate a key and encrypt data in one go with Cryppo.encrypt/2:{encrypted_data, encryption_key} = Cryppo.encrypt(data, encryption_strategy)Cryppo.EncryptedData structs can be serialized as a string using function Cryppo.serialize/1. The serialized payload can be stored directly in a data store.serialized = Cryppo.serialize(encrypted_data)The serialized payload can later be loaded by using Cryppo.load/1 and decrypted with Cryppo.decrypt/2 and the passphrase:{:ok, encrypted} = Cryppo.load(serialized) {:ok, decrypted} = Cryppo.decrypt(encrypted, encryption_key) Cryppo.inspect(decrypted) #=&gt; &quot;some data to encrypt&quot;","ref":"readme.html#encrypt-and-decrypt-data-using-a-generated-cryptographic-key","title":"CryppoEx - Encrypt and decrypt data using a generated cryptographic key","type":"extras"},{"doc":"For authentication purposes, a sender can sign a message with their private key, and a recipient can verify this signature using the sender's public key.private_key = Cryppo.generate_encryption_key(&quot;Rsa4096&quot;) rsa_signature = Cryppo.Rsa4096.sign(&quot;data to verify&quot;, private_key) serialized = Cryppo.serialize(rsa_signature) {:ok, signature} = Cryppo.load(serialized) Cryppo.Rsa4096.verify(signature, Cryppo.Rsa4096.private_key_to_public_key(private_key)) # =&gt; true","ref":"readme.html#signing-and-verification","title":"CryppoEx - Signing and verification","type":"extras"},{"doc":"Aes256GcmAes256Gcm was chosen because it provides authenticated encryption. An error will be raised if an incorrect value, such as the encryption key, were used during decryption. This means you can always be sure that the decrypted data is the same as the data that was originally encrypted.","ref":"readme.html#encryption-strategies","title":"CryppoEx - Encryption Strategies","type":"extras"},{"doc":"Pbkdf2HmacPbkdf2Hmac generates cryptographically secure keys from potentially insecure sources such as user-generated passwords.The derived key is cryptographically secure such that brute force attacks directly on the encrypted data is infeasible. The amount of computational effort required to complete the operation can be tweaked. This ensures that brute force attacks on the password encrypted data.","ref":"readme.html#key-derivation-strategies","title":"CryppoEx - Key Derivation Strategies","type":"extras"},{"doc":"CryppoEx exposes its functionality via a command line interface.In order to use the CryppoEx CLI, you need to build an escript executable with the following command:MIX_ENV=prod mix escript.buildThe generated executable can run on any machine that has Erlang installed and does not require Elixir to be installed.cryppo genkeyGenerate a new (random) encryption key - printed as base64 encodedUSAGE cryppo genkey -s [ENCRYPTION_STRATEGY] OPTIONS -s, --strategy=strategy encryption strategy (defaults to Aes256Gcm) EXAMPLES cryppo genkey cryppo genkey --strategy=Aes256Gcmcryppo genkeypairGenerate a new RSA key pair, writing the private and public keys to files.USAGE cryppo genkeypair -p [PRIVATE_KEY_FILE] -P [PUBLIC_KEY_FILE] OPTIONS -p, --privateKeyOut=privateKeyOut (required) Private key output path -P, --publicKeyOut=publicKeyOut (required) Public key output path EXAMPLE cryppo genkeypair -p private.pem -P public.pemcryppo encryptEncrypt data with a generated keyUSAGE cryppo encrypt -v [DATA] -k [KEY] -s [ENCRYPTION_STRATEGY] cryppo encrypt -v [DATA] -P [PUBLIC_KEY_FILE] OPTIONS -v, --value=value (required) value to encrypt -s, --strategy=strategy encryption strategy (defaults to Aes256Gcm) -k, --key=key base64 encoded data encryption key -P, --publicKeyFile=publicKeyFile public key file (if encrypting with RSA) EXAMPLES encrypt -v &quot;hello world&quot; -k vm8CjugMda2zdjsI9W25nH-CY-84DDYoBxTFLwfKLDk= -s Aes256Gcm encrypt -v &quot;hello world&quot; -P public.pemcryppo decryptDecrypt a serialized encrypted valueUSAGE cryppo decrypt -e [ENCRYPTED_DATA] -k [KEY] -s [ENCRYPTION_STRATEGY] cryppo decrypt -e [ENCRYPTED_DATA] -p [PRIVATE_KEY_FILE] OPTIONS -e, --encrypted=encrypted (required) serialized encrypted value -s, --strategy=strategy encryption strategy (defaults to Aes256Gcm) -k, --key=key base64 encoded data encryption key -p, --privateKeyFile=privateKeyFile private key file (if encrypting with RSA) EXAMPLES cryppo decrypt -e &quot;Aes256Gcm.gSAByGMq4edzM0U=.LS0tCml2OiAhYmluYXJ5IHwtCiAgaW1QL09qMWZ6eWw0cmwwSgphdDogIWJpbmFyeSB8LQogIE5SbjZUQXJ2bitNS1 Z5M0FpZEpmWlE9PQphZDogbm9uZQo=&quot; -k vm8CjugMda2zdjsI9W25nH-CY-84DDYoBxTFLwfKLDk= cryppo decrypt -e &quot;Rsa4096.bJjV2g_RBZKeyqBr-dSjPAc3qtkTgd0=.LS0tCnt9Cg==&quot; -p private.pemcryppo encrypt-derEncrypt data with a derived keyUSAGE cryppo encrypt-der -v [DATA] -w [PASSWORD] -s [ENCRYPTION_STRATEGY] -d [DERIVATION_STRATEGY] OPTIONS -v, --value=value (required) value to encrypt -w, --password=password (required) password for key derivation -s, --strategy=strategy encryption strategy (defaults to Aes256Gcm) -d, --derivation-strategy=strategy derivation strategy (defaults to Pbkdf2Hmac) EXAMPLES cryppo encrypt-der -v &quot;hello world&quot; -w &quot;secret phrase&quot; -s Aes256Gcm -d Pbkdf2Hmac cryppo encrypt-der -v &quot;hello world&quot; -w &quot;secret phrase&quot;cryppo decrypt-derDecrypt a serialized encrypted value with a derived keyUSAGE cryppo decrypt-der -e [ENCRYPTED_DATA] -p [PASSPHRASE] OPTIONS -e, --encrypted=encrypted (required) serialized encrypted value -p, --passphrase=passphrase (required) passphrase for key derivation EXAMPLES cryppo decrypt-der -p &quot;secret phrase&quot; \\ -e &quot;Aes256Gcm.e-IJT9E8ew3wlz8=.LS0tCmFkOiBub25lCmF0OiAhIWJpbmFyeSB8LQogIHpTRzQzbVhlSFBsR3ZQQVZoNTVJQUE9PQppdjogISFiaW5hcnkgfC0KICBMU2NDNmVCZ2wrUCtuUkpaCg==.Pbkdf2Hmac.LS0tCidpJzogMjEzMjIKJ2l2JzogISFiaW5hcnkgfC0KICBzTmlGT21xWEg5b1piNzRNVElCcGxvNHlHV2M9CidsJzogMzIK&quot;cryppo sign FILE DESTINATIONSign a file with an RSA private key and write the signed contents to a new fileUSAGE cryppo sign -p [PRIVATE_KEY_FILE] FILE DESTINATION ARGUMENTS FILE File to sign DESTINATION file to write the resulting signed content to OPTIONS -p, --privateKeyFile=privateKeyFile (required) path to the private key file EXAMPLE cryppo sign -p private.pem my_file.txt my_file.signed.txtcryppo verify FILE DESTINATIONVerify an RSA signed file and write the contents to another file.USAGE cryppo verify -P [PUBLIC_KEY_FILE] FILE DESTINATION ARGUMENTS FILE Signed file contents to verify DESTINATION File to write the resulting verified content to OPTIONS -P, --publicKeyFile=publicKeyFile (required) path to the public key file EXAMPLE cryppo verify -P public.pem my_file.signed.txt my_file.txt","ref":"readme.html#command-line-interface","title":"CryppoEx - Command Line Interface","type":"extras"}]